;NSIS Script For Stan Payne Created by Malcolm Lim - mlbl@yahoo.com

;You need at least NSIS 1.9 or higher to compile this script. Get it at
;http://www.nullsoft.com/free/nsis

;It is better to compress with the new Bzip2 compression as it provides a
;much better and stronger compression ratio compared to the default Zlib that
;came with NSIS.

;All you need to do is very simple : make modifications to this script as you
;see fit, then just go to your NSIS directory and type in :
;makensis-bz2 yourmod.nsi
;OR
;makensis yourmod.nsi

;The first is Bzip2 compression (better) and the other is the Zlib compression.

;Some of the sections in this script can be removed if it does not apply to your
;mod, for example you may remove the uninstall section if you don't want people
;to remove / uninstall your mod. But you must also remove the :
;WriteUninstaller "Uninst.exe" statement under the files section.

;Backgound Colors
BGGradient 0000A0 000000 FFFFFF
BrandingText "Stan Payne"
;Title Of Your Application
Name "Stan Payne"
Icon "d:\nsis\Setup2.ico"
ShowInstDetails Show
ShowUninstDetails Show
InstallColors 000080 FFFFFF
InstProgressFlags smooth colored

;Components to install
ComponentText "Select the components to install:" "Select the Installation Type"

;you can customise this, if you use more than one word, enclose them in quotes
;for example : InstType "Full Installation"
InstType Full
InstType Minimal

;Change the path d:\nsis to reflect where you installed NSIS.
EnabledBitmap "d:\nsis\contrib\three-check.bmp"
DisabledBitmap "d:\nsis\contrib\one-nocheck.bmp"

;Do A CRC Check
CRCCheck On
SetOverwrite IfNewer
;Output File Name
OutFile "stanpaynesetup.exe"

;This will check if maxpayne exists so that the user will not try to install it
;in the wrong folder.
Function .onVerifyInstDir
  IfFileExists $INSTDIR\maxpayne.exe Good
    Abort
  Good:
FunctionEnd

;Sets the default InstallDir if the maxpayne registry key is not found...
InstallDir "c:\maxpayne"
InstallDirRegKey HKCR Applications\Maxpayne.exe\shell\Open\command ''

;Relating to setting the install directory derived from a registry key...
Function .onInit
  StrLen $1 $INSTDIR ;get the length of the directory...
  IntOp $1 $1 - 17 ;subtract 17 from that number...
  ;copy the variable $instdir to $instdir with maxlen of the variable $1...done!
  StrCpy $INSTDIR $INSTDIR $1
FunctionEnd

;The text to prompt the user to enter a directory
DirText "Please enter your Max Payne folder below"

Section "Stan Payne Mod (Required)"
  SectionIn 12 ;This determines the components type that this section will appear on. 1 = Full, 2 = Minimal.
  ;Install Files
  SetOutPath $INSTDIR
  SetCompress Auto
  File /r "d:\maxpayne\stan*.*"
  ; Write the uninstall keys for Windows
  WriteUninstaller "Uninst.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Stan Payne" "DisplayName" "Stan Payne (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Stan Payne" "UninstallString" "$INSTDIR\Uninst.exe"
SectionEnd

Section "Start Menu Shortcuts"
  ;Add Shortcuts
  SectionIn 1 ;This determines the components type that this section will appear on. 1 = Full, 2 = Minimal.
  CreateDirectory "$SMPROGRAMS\Max Payne Mods\Stan Payne"
  CreateShortCut "$SMPROGRAMS\Max Payne Mods\Stan Payne\Stan Payne Readme.lnk" "$INSTDIR\Stan_Payne.txt" "" "$INSTDIR\Stan_Payne.txt" 0
  CreateShortCut "$SMPROGRAMS\Max Payne Mods\Stan Payne\Uninstall.lnk" "$INSTDIR\uninst.exe" "" "$INSTDIR\uninst.exe" 0
SectionEnd

UninstallText "This will uninstall Stan Payne from your system"
UninstallIcon "D:\nsis\uninstall.ico"

Section Uninstall
  ;Delete Files
  Delete "$SMPROGRAMS\Max Payne Mods\Stan Payne\*.*"
  RmDir "$SMPROGRAMS\Max Payne Mods\Stan Payne"
  RmDir "$SMPROGRAMS\Max Payne Mods"

  ;Delete Unistall Registry Entries
  DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Stan Payne"
  DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Stan Payne"
  Delete "$INSTDIR\stan*.*"
SectionEnd